package com.jdbc.resultset.extractor;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.ResultSetExtractor;

public class TechEditorDao {

	private JdbcTemplate templateObj;

	public void setTemplateObj(JdbcTemplate template) {
		this.templateObj = template;
	}

	// Implementing Custom ResultSetExtractor To Fetch Data From The Db
	public List<TechEditor> getAllEditors() {
		return templateObj.query("SELECT * FROM tech_editors", new ResultSetExtractor<List<TechEditor>>() {
			public List<TechEditor> extractData(ResultSet resultSetObj) throws SQLException, DataAccessException {
				List<TechEditor> editorList = new ArrayList<TechEditor>();
				while(resultSetObj.next()) {
					TechEditor techEditorObj = new TechEditor();
					techEditorObj.setEditor_id(resultSetObj.getInt(1));
					techEditorObj.setEditor_name(resultSetObj.getString("name"));
					techEditorObj.setEditor_salary(resultSetObj.getFloat(3));
					editorList.add(techEditorObj);
				}
				return editorList;
			}
		});
	}
}